#pragma once

/*
Nbv{[hf[^Rs[Ăf[^

̓Rs[
GDInh́H@rbg}bvGdiplus::Bitmap*^ɃRs[ĂH

*/

#define CP_CBDATA_UTF16	-1
#define CP_CBDATA_UTF16BE -2
#define CP_CBDATA_UNKNOWN -10


extern BOOL GetClipboardFormatNameString(UINT nCF, CString& strName, BOOL& bRegisteredFormat);
extern CString GetClipboardFormatNameString(UINT nCF);
extern CString FORMATETCAspect2String(DWORD dwAspect);
extern CString FORMATETCTymed2String(DWORD tymed);
extern CString FORMATETC2String(const FORMATETC& fmtetc);
extern CString FORMATETC2ShortString(const FORMATETC& fmtetc);
extern void FORMATETC2ShortStringArray(vector<FORMATETC>& arrayFormats, CStringArray& arrayString);

class CCBDataCreateContext
{
public:
	COleDataObject* m_pDataObject;	// 荞݌BNULLȂNbv{[hB
	HPALETTE m_hPalette;			// pbgBx擾ƂȂȂ̂ŁuŏɁv荞ŃRs[Ă
	BOOL m_bPaletteCopied;			// pbgRs[ꂽBŎɉKv

	ULONGLONG m_cbTotal;			// tH[}bgŎ荞񂾃TCY

	CCBDataCreateContext(COleDataObject* m_pDataObject, class CCopyingDialog* pDlg);
	virtual ~CCBDataCreateContext();

	// ԕ\
	class CCopyingDialog* m_pDlg;

	void SetName(const CString& strName);
	void SetName(FORMATETC& fmtetc);
	BOOL IsCancelled();
	CString GetAbortText();
};

///////////////////////////////////

class CCBData : public CObject
{
	DECLARE_DYNAMIC(CCBData)
public:
	FORMATETC m_fmtetc;		// Nbv{[hf[^cfFormatȊO͓ĂȂ
	DWORD m_tymed;			// ۂɎ荞݂sTYMED

	CString m_strType;		// FileContents̃^Cv
	// ̃f[^̂Ƀt@ĆBCFSTR_FILECONTENTS[n]
	CString m_strFileName;
	CString m_strDispFileName;

	enum {
		icontypeFolder,
		icontypeFile,
		icontypeGdi,
		icontypeUnknown,
	};
	int m_nIconType;

	// ǉvpeB
	CStringArray m_arrayProperties;


	// HGLOBAL̒gRs[Ă
	ULONGLONG m_cbMem;
	CString m_strMemDataFileName;	// C[Wێt@C


	// FILECONTENTS̃Tuc[
	shared_ptr<class CCBDataArray> m_pArrayChildren;

	// \̃qg
	enum {
		suitabletypeHex = 0,
		suitabletypeText,
		suitabletypeImage,
		suitabletypeProperty,
	};

	// ƃGA
	BOOL m_bPlaceHolder;
	CComPtr<IShellFolder> m_pShellFolder;
	CComPtr<IStorage> m_pStorage;

protected:
	int m_suitabletype;
public:
	int GetSuitableType();
	void SetSuitableType(int suitabletype);
protected:
	CString GetFormatTypeString();
	int m_nCodePage;	// eLXg\ɓKĂƎvR[hy[WB-1=UTF16 0=ANSI
public:
	int GetSuitableCodePage();
//	void SetSuitableCodePage(int nCodePage);

	static shared_ptr<CCBData> Create(CCBDataCreateContext* pctx, FORMATETC& fmtetc);
	static shared_ptr<CCBData> CreateSub(CCBDataCreateContext* pctx, FORMATETC& fmtetc, DWORD tymed);
	static shared_ptr<CCBData> CreateFromHGlobal(CCBDataCreateContext* pctx, HGLOBAL);
	static shared_ptr<CCBData> CreateFromFile(CCBDataCreateContext* pctx, const WCHAR* pszPathName);
	static shared_ptr<CCBData> CreateFromIStream(CCBDataCreateContext* pctx, IStream* pStream);
	static shared_ptr<CCBData> CreateFromIStorage(CCBDataCreateContext* pctx, IStorage* pStorage);
	static shared_ptr<CCBData> CreateFromIShellFolder(CCBDataCreateContext* pctx, IShellFolder* pFolder);
	static shared_ptr<CCBData> CreateFromDirectory(CCBDataCreateContext* pctx, const CString& strDir);
	static shared_ptr<CCBData> CreateFromHBITMAP(HBITMAP hBitmap, HPALETTE hPalette);
	static shared_ptr<CCBData> CreateFromMFPICT(HMETAFILEPICT hMetaFilePict);
	static shared_ptr<CCBData> CreateFromHENHMETAFILE(HENHMETAFILE hEnhMetaFile);
	static shared_ptr<CCBData> CreateDummyFolder(const CString& strType);
	static shared_ptr<CCBData> CreateErrorData(const CString& strError);
	BOOL ParseHDrop(CCBDataCreateContext* pctx, BOOL bAddFiles);
	BOOL ParseShellIDList(CCBDataCreateContext* pctx);
	void ProcessFileContents();

public:
	CCBData();
	virtual ~CCBData();
	virtual void DeriveFrom(shared_ptr<CCBData> pData);
	bool LoadMemData(vector<BYTE>& buf);
	virtual shared_ptr<Image> GetImage(int& cx, int& cy, int& nBitsPerPixel);
	virtual CString GetTitle();

	friend class CCBDataArray;
};

///////////////////////////////////

class CCBData_FileDescriptor : public CCBData
{
	DECLARE_DYNAMIC(CCBData_FileDescriptor)
public:
	CStringArray m_arrayFileNames;
	CCBData_FileDescriptor();
	static shared_ptr<CCBData_FileDescriptor> ChangeClassFrom(shared_ptr<CCBData> pData) {shared_ptr<CCBData_FileDescriptor> p = make_shared<CCBData_FileDescriptor>(); p->DeriveFrom(pData); return p;}
	virtual ~CCBData_FileDescriptor();
	BOOL ParseFileDescriptorW();
	BOOL ParseFileDescriptorA();
};

///////////////////////////////////

class CCBData_GDI : public CCBData
{
	DECLARE_DYNAMIC(CCBData_GDI)
public:
	int m_cxImage;
	int m_cyImage;
	int m_nBitsPerPixel;

	CCBData_GDI() : m_cxImage(0), m_cyImage(0), m_nBitsPerPixel(0) 
	{
		m_suitabletype = suitabletypeImage;
		m_nIconType = icontypeGdi;
	}
	virtual ~CCBData_GDI() {}
	virtual shared_ptr<Image> GetImage(int& cx, int& cy, int& nBitsPerPixel) override;
	// TuNXłI[o[Ch
	virtual shared_ptr<Image> GetImageSub() {return NULL;}
};

///////////////////////////////////

class CCBData_HBITMAP : public CCBData_GDI
{
	DECLARE_DYNAMIC(CCBData_HBITMAP)
public:
	HBITMAP m_hBitmap;
	HPALETTE m_hPalette;

	CCBData_HBITMAP();
	virtual ~CCBData_HBITMAP();
	void CopyImage(HBITMAP hbm, HPALETTE hPal);
	virtual shared_ptr<Image> GetImageSub() override;
};

///////////////////////////////////

class CCBData_HENHMF : public CCBData_GDI
{
	DECLARE_DYNAMIC(CCBData_HENHMF)
public:
	HENHMETAFILE m_hEM;

	CCBData_HENHMF();
	virtual ~CCBData_HENHMF();
	void CopyImage(HENHMETAFILE hEM);
	virtual shared_ptr<Image> GetImageSub() override;
};

///////////////////////////////////

class CCBData_HMETAFILEPICT : public CCBData_GDI
{
	DECLARE_DYNAMIC(CCBData_HMETAFILEPICT)
public:
	HMETAFILEPICT m_hMetaFilePict;	// O[o
	HMETAFILE m_hMF;				// ɂnh

	CCBData_HMETAFILEPICT();
	virtual ~CCBData_HMETAFILEPICT();
	void CopyImage(HMETAFILEPICT hMetaFilePict);
	virtual shared_ptr<Image> GetImageSub() override;
};

///////////////////////////////////

class CCBData_DIB : public CCBData
{
	DECLARE_DYNAMIC(CCBData_DIB)
protected:
	vector<BYTE> m_buf;

public:
	CCBData_DIB();
	virtual ~CCBData_DIB();
	static shared_ptr<CCBData_DIB> ChangeClassFrom(shared_ptr<CCBData> pData) {shared_ptr<CCBData_DIB> p = make_shared<CCBData_DIB>(); p->DeriveFrom(pData); return p;}
	virtual shared_ptr<Image> GetImage(int& cx, int& cy, int& nBitsPerPixel) override;

};

///////////////////////////////////

class CCBData_DragImageBits : public CCBData
{
	DECLARE_DYNAMIC(CCBData_DragImageBits)
protected:
	vector<BYTE> m_buf;
public:
	CCBData_DragImageBits();
	virtual ~CCBData_DragImageBits();
	static shared_ptr<CCBData_DragImageBits> ChangeClassFrom(shared_ptr<CCBData> pData) {shared_ptr<CCBData_DragImageBits> p = make_shared<CCBData_DragImageBits>(); p->DeriveFrom(pData); return p;}
	virtual shared_ptr<Image> GetImage(int& cx, int& cy, int& nBitsPerPixel) override;
};

class CCBDataArray : public vector<shared_ptr<CCBData>>
{
public:
	CCBDataArray() {}
	virtual ~CCBDataArray() {}

	// Cc[쐬
	static void EnumAllFormats(COleDataObject* pDataObject, vector<FORMATETC>& arrayFormats);
	void CreateItems(COleDataObject* pDataObject, vector<FORMATETC>& arrayFromats);
protected:
	CCBData_FileDescriptor* FindFileDescriptor(CCBData* pDataContents);
public:

	// Tuc[쐬
	void CreateSubTreeFromCIDA(CCBDataCreateContext* pctx, IShellFolder* pFolder, CIDA* pida);
	void CreateSubTreeFromIStorage(CCBDataCreateContext* pctx, IStorage* pStorage);
	void CreateSubTreeFromIShellFolder(CCBDataCreateContext* pctx, IShellFolder* pShellFolder);
	void CreateSubTreeFromDirectory(CCBDataCreateContext* pctx, const CString& strDir);
	void CreateSubTreeFromHDROP(CCBDataCreateContext* pctx, HDROP hdrop);
	void CreateSubTreeFromFileDescriptor(CCBDataCreateContext* pctx, CCBData_FileDescriptor* pDataDescriptor, FORMATETC& fmtetcContents);
};
