#pragma once

typedef void (*PFNHEXVIEWCTRL_GETDATA_CALLBACK)(ULONGLONG pos, DWORD len, void* pBuf, DWORD_PTR dw1, DWORD_PTR dw2);

// CHexViewCtrl

class CHexViewCtrl : public CWnd
{
	DECLARE_DYNAMIC(CHexViewCtrl)

public:
	PFNHEXVIEWCTRL_GETDATA_CALLBACK m_pfnCallback;
	DWORD_PTR m_dwCallbackData1;
	DWORD_PTR m_dwCallbackData2;
	ULONGLONG m_cbData;
	int m_nLineWidth;
	vector<BYTE> m_buf;

	// gbNX
	CFont m_font;
	int m_cxChar;
	int m_cyChar;
	int m_cyLine;
	int m_cxMargin;
	int m_cyMargin;
	int m_cxCaret;

	COLORREF m_crBackground;
	COLORREF m_crText;
	COLORREF m_crTextBack;
	COLORREF m_crSelText;
	COLORREF m_crSelTextBack;

	// XN[
	LONGLONG m_cLines;
	LONGLONG m_nTopLine;
	int m_nLinesInWindow;
	LONGLONG m_nVScrollMax;
	int m_nVScrollFactor;	// INT_MAX𒴂Ăn1ɂ

	int m_cchAddress;		// AhXB4or8or16
	int m_cchLine;
	int m_nColsInWindow;
	int m_nHScrollMax;
	int m_nLeftCol;

	// J[\
	LONGLONG m_nCurLine;
	int m_nCurCol;
	LONGLONG m_nSelLine;
	int m_nSelCol;

	LONGLONG m_nSelStartLine;
	int m_nSelStartCol;
	LONGLONG m_nSelEndLine;
	int m_nSelEndCol;

	// }EX
	BOOL m_bCapture;
	CPoint m_ptLastMousePos;

	BOOL m_bHaveFocus;
	BOOL m_bCaretShown;

public:
	CHexViewCtrl();
	virtual ~CHexViewCtrl();

	BOOL Create(DWORD dwStyle, CWnd* pWndParent, UINT nID);
	void SetData(ULONGLONG cbData, PFNHEXVIEWCTRL_GETDATA_CALLBACK pfn, DWORD_PTR dw1, DWORD_PTR dw2);
	void SetLineWidth(int nWidth);
	LONGLONG AddressFromLineCol(LONGLONG nLine, int nCol, BOOL bEnd);

protected:
	void SetCurPos(LONGLONG nLine, int nCol, BOOL bSelecting);
	void ShowCaretAtCurPos();
	void ScrollToShowCurPos();
	void VScroll(LONGLONG nNewTopLine, BOOL bSetBar);
	void HScroll(int nNewLeftCol, BOOL bSetBar);

	int GetLineWidthOfThisLine(LONGLONG nLine);
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	void DrawLine(CDC* pDC, LONGLONG nLine, int y);
	void UpdateSelStartEnd();
	void GetSelPositionInLine(LONGLONG nLine, int& nSelCol, int& cSelCols);
	int GetLineLength(LONGLONG nLine);
	CString GetLineText(LONGLONG nLine);
	void GetLineText(WCHAR* pchOutBuf, LONGLONG nLine);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSysColorChange();
	void GetSysColors();
	void CalcScrollParam();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	BOOL HitTest(CPoint point, LONGLONG& nLine, int& nCol, BOOL bBetween);
	void SelMouse(CPoint point);
	void SelectWord(LONGLONG nLine, int nCol);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	void CursorLeft(BOOL bSelecting);
	void CursorRight(BOOL bSelecting);
	void CursorUp(BOOL bSelecting);
	void CursorDown(BOOL bSelecting);
	void CursorPrevWord(BOOL bSelecting);
	void CursorNextWord(BOOL bSelecting);
	void CursorPageUp(BOOL bSelecting);
	void CursorPageDown(BOOL bSelecting);
	void CursorBOL(BOOL bSelecting);
	void CursorEOL(BOOL bSelecting);
	void CursorBOF(BOOL bSelecting);
	void CursorEOF(BOOL bSelecting);
	afx_msg UINT OnGetDlgCode();
	afx_msg void OnCancelMode();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCopy(CCmdUI *pCmdUI);
	afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
	afx_msg void OnEditSelectAll();
	afx_msg void OnUpdateEditSelectAll(CCmdUI *pCmdUI);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnEditExport();
	afx_msg void OnUpdateEditExport(CCmdUI *pCmdUI);
};


