#include "stdafx.h"
#include "NFile.h"

NFile::NFile()
	: m_hFile(INVALID_HANDLE_VALUE)
{

}

NFile::~NFile()
{
	if (m_hFile != INVALID_HANDLE_VALUE) {
		Close();
	}
}

bool NFile::OpenExistingFileToRead(const CString& strFileName)
{
	ASSERT(m_hFile == INVALID_HANDLE_VALUE);

	m_hFile = CreateFile(strFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (m_hFile != INVALID_HANDLE_VALUE) {
		return true;
	}
	else {
		return false;
	}
}

bool NFile::CreateNewFileToWrite(const CString& strFileName)
{
	ASSERT(m_hFile == INVALID_HANDLE_VALUE);

	m_hFile = CreateFile(strFileName, GENERIC_READ | GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (m_hFile != INVALID_HANDLE_VALUE) {
		return true;
	}
	else {
		return false;
	}
}

void NFile::Close()
{
	if (m_hFile != INVALID_HANDLE_VALUE) {
		CloseHandle(m_hFile);
		m_hFile = INVALID_HANDLE_VALUE;
	}
}

DWORD NFile::Read(void* buf, DWORD cbBuf)
{
	DWORD cbRead = 0;
	if (!ReadFile(m_hFile, buf, cbBuf, &cbRead, NULL)) {
		return 0;
	}
	return cbRead;
}

bool NFile::Rewind()
{
	return SeekSet(0);
}

bool NFile::SeekSet(ULONGLONG posFromBOF)
{
	LARGE_INTEGER liPos = { 0 };
	liPos.QuadPart = posFromBOF;
	LARGE_INTEGER liNewPos = { 0 };

	if (!SetFilePointerEx(m_hFile, liPos, &liNewPos, SEEK_SET)) {
		return false;
	}
	if (liNewPos.QuadPart != liPos.QuadPart) {
		return false;
	}

	return true;

}

bool NFile::Write(void* buf, DWORD cbBuf)
{
	DWORD cbWritten = 0;
	if (!WriteFile(m_hFile, buf, cbBuf, &cbWritten, NULL)) {
		return false;
	}
	if (cbWritten != cbBuf) {
		return false;
	}
	return true;
}

ULONGLONG NFile::GetLength()
{
	LARGE_INTEGER li = { 0 };
	if (!GetFileSizeEx(m_hFile, &li)) {
		return 0;
	}
	return li.QuadPart;
}
